'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _StyledInput = require('../StyledInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'BambiDatePicker__Wrapper'
})(['display:block;position:relative;width:auto;font-size:', ';.day{display:inline-block;width:3em;margin-right:0.5em;}.month{display:inline-block;width:3em;margin-right:0.5em;}.year{display:inline-block;width:5em;}.error-section{display:block;font-size:inherit;color:#f26455;padding:0;margin:0;}'], function (props) {
  return props.fontSize + 'px';
});

// DATA
var days = [];
var months = [];
var years = [];
for (var d = 1; d <= 31; d += 1) {
  days.push(d);
}
for (var m = 1; m <= 12; m += 1) {
  months.push(m);
}
for (var y = new Date().getFullYear(); y >= 1930; y -= 1) {
  years.push(y);
}

var BambiDatePicker = function (_React$Component) {
  _inherits(BambiDatePicker, _React$Component);

  // eslint-disable-line react/prefer-stateless-function
  function BambiDatePicker(props) {
    _classCallCheck(this, BambiDatePicker);

    var _this = _possibleConstructorReturn(this, (BambiDatePicker.__proto__ || Object.getPrototypeOf(BambiDatePicker)).call(this, props));

    _this.state = {
      day: props.initialValue ? props.initialValue.split('.')[0] : '',
      month: props.initialValue ? props.initialValue.split('.')[1] : '',
      year: props.initialValue ? props.initialValue.split('.')[2] : ''
    };
    _this.setDay = _this.setDay.bind(_this);
    _this.setMonth = _this.setMonth.bind(_this);
    _this.setYear = _this.setYear.bind(_this);
    return _this;
  }

  _createClass(BambiDatePicker, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.value) {
        var split = this.props.value.split('.');
        this.setState({ // eslint-disable-line
          day: split[0],
          month: split[1],
          year: split[2]
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.initialValue) {
        var split = nextProps.initialValue.split('.');
        this.setState({ // eslint-disable-line
          day: split[0],
          month: split[1],
          year: split[2]
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps !== this.props || nextState !== this.state;
    }
  }, {
    key: 'setDay',
    value: function setDay(e) {
      var _this2 = this;

      var input = e.target.value;
      // if (input[0] === '0') { input = input.slice(1, input.length); }
      e.preventDefault();
      if (input.length < 3 || !input.length) {
        var val = input.split('').filter(function (char) {
          return char.charCodeAt(0) > 47 && char.charCodeAt(0) < 58;
        }).join('');
        this.setState({ day: val, error: null }, function () {
          return _this2.validate();
        });
      }
      if (input.length === 2) {
        document.getElementById(this.props.id + '-month-input').focus();
      }
    }
  }, {
    key: 'setMonth',
    value: function setMonth(e) {
      var _this3 = this;

      var input = e.target.value;
      // if (input[0] === '0') { input = input.slice(1, input.length); }
      e.preventDefault();
      if (input.length < 3 || !input.length) {
        var val = input.split('').filter(function (char) {
          return char.charCodeAt(0) > 47 && char.charCodeAt(0) < 58;
        }).join('');
        this.setState({ month: val, error: null }, function () {
          return _this3.validate();
        });
      }
      if (input.length === 2) {
        document.getElementById(this.props.id + '-year-input').focus();
      }
    }
  }, {
    key: 'setYear',
    value: function setYear(e) {
      var _this4 = this;

      var input = e.target.value;
      e.preventDefault();
      if (input.length < 5 || !input.length) {
        var val = input.split('').filter(function (char) {
          return char.charCodeAt(0) > 47 && char.charCodeAt(0) < 58;
        }).join('');
        this.setState({ year: val, error: null }, function () {
          _this4.validate();
        });
      }
    }
  }, {
    key: 'getDateValue',
    value: function getDateValue() {
      var value = this.state.day + '.' + this.state.month + '.' + this.state.year;
      this.props.onDateChanged({ value: value, error: this.state.error });
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _this5 = this;

      if (this.state.day && this.state.month && this.state.year) {
        var date = new Date(Number(this.state.year), Number(this.state.month) - 1, Number(this.state.day));
        var convertedDate = date.getFullYear() + ' ' + (date.getMonth() + 1) + ' ' + date.getDate();
        var givenDate = Number(this.state.year) + ' ' + Number(this.state.month) + ' ' + Number(this.state.day);
        if (convertedDate !== givenDate) {
          this.setState({ error: 'תאריך לא תקין' }, function () {
            return _this5.getDateValue();
          });
        } else if (this.props.maxDate) {
          var split = this.props.maxDate.split('.');
          var max = new Date(Number(split[2]), Number(split[1]) - 1, Number(split[0])).getTime();
          if (max < new Date(date).getTime()) {
            this.setState({ error: 'תאריך קלט מאוחר מהתאריך המותר' }, function () {
              return _this5.getDateValue();
            });
          }
        }
        if (this.props.minDate) {
          var _split = this.props.minDate.split('.');
          var min = new Date(Number(_split[2]), Number(_split[1]) - 1, Number(_split[0])).getTime();
          if (min > new Date(date).getTime()) {
            this.setState({ error: 'תאריך קלט מוקדם מהתאריך המותר' }, function () {
              return _this5.getDateValue();
            });
          }
        }
        this.getDateValue();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        Wrapper,
        {
          id: this.props.id,
          fontSize: this.props.fontSize
        },
        _react2.default.createElement(_StyledInput.StyledInput, {
          fontSize: this.props.fontSize,
          value: this.state.day,
          onChange: this.setDay,
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          placeholder: 'יום',
          type: 'number',
          id: this.props.id + '-day-input',
          className: 'day'
        }),
        _react2.default.createElement(_StyledInput.StyledInput, {
          fontSize: this.props.fontSize,
          value: this.state.month,
          onChange: this.setMonth,
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          placeholder: 'חודש',
          type: 'number',
          id: this.props.id + '-month-input',
          className: 'month'
        }),
        _react2.default.createElement(_StyledInput.StyledInput, {
          fontSize: this.props.fontSize,
          value: this.state.year,
          onChange: this.setYear,
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          placeholder: 'שנה',
          disabled: this.props.disableYear,
          type: 'number',
          id: this.props.id + '-year-input',
          className: 'year'
        }),
        this.state.error && _react2.default.createElement(
          'span',
          { className: 'error-section' },
          this.state.error
        )
      );
    }
  }]);

  return BambiDatePicker;
}(_react2.default.Component);

BambiDatePicker.propTypes = {
  maxDate: _propTypes2.default.string,
  minDate: _propTypes2.default.string,
  value: _propTypes2.default.string,
  id: _propTypes2.default.string,
  initialValue: _propTypes2.default.string,
  onDateChanged: _propTypes2.default.func,
  disableYear: _propTypes2.default.bool,
  fontSize: _propTypes2.default.number
};

exports.default = BambiDatePicker;