'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _StyledInput = require('../StyledInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'EmailAddress__Wrapper'
})(['display:block;position:relative;font-size:', ';width:100%;.error-section{display:block;font-size:inherit;color:#f26455;padding:0;margin:0;}'], function (props) {
  return props.fontSize + 'px';
});
var emailRegexp = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/; // eslint-disable-line

var EmailAddress = function (_React$PureComponent) {
  _inherits(EmailAddress, _React$PureComponent);

  // eslint-disable-line react/prefer-stateless-function
  function EmailAddress(props) {
    _classCallCheck(this, EmailAddress);

    var _this = _possibleConstructorReturn(this, (EmailAddress.__proto__ || Object.getPrototypeOf(EmailAddress)).call(this, props));

    _this.state = {
      value: '',
      error: ''
    };
    _this.setValue = _this.setValue.bind(_this);
    _this.validate = _this.validate.bind(_this);
    return _this;
  }

  _createClass(EmailAddress, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.value) {
        this.setState(function () {
          return { value: _this2.props.value };
        }); // eslint-disable-line
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state !== nextState || nextProps !== this.props;
    }
  }, {
    key: 'setValue',
    value: function setValue(e) {
      e.preventDefault();
      this.setState({ value: e.target.value, error: '' });
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _this3 = this;

      if (emailRegexp.test(this.state.value) === false) {
        this.setState({ error: 'כתובת לא תקינה' }, function () {
          return _this3.props.onEmailChanged({ value: _this3.state.value, error: _this3.state.error });
        });
      } else {
        this.props.onEmailChanged({ value: this.state.value, error: this.state.error });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        Wrapper,
        null,
        _react2.default.createElement(_StyledInput.StyledInput, _extends({}, this.props, {
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          fontSize: this.props.fontSize,
          onChange: this.setValue,
          onBlur: this.validate,
          value: this.state.value,
          'aria-label': this.props.ariaLabel,
          disabled: this.props.disabled,
          id: this.props.id
        })),
        _react2.default.createElement(
          'div',
          { className: 'error-section' },
          this.state.error
        )
      );
    }
  }]);

  return EmailAddress;
}(_react2.default.PureComponent);

EmailAddress.propTypes = {
  onEmailChanged: _propTypes2.default.func,
  value: _propTypes2.default.string,
  ariaLabel: _propTypes2.default.string,
  id: _propTypes2.default.string,
  disabled: _propTypes2.default.bool
};

exports.default = EmailAddress;