'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'EnumSelection__Wrapper'
})(['width:100%;input{display:none;}']);
var ListWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'EnumSelection__ListWrapper'
})(['direction:rtl;display:flex;justify-content:flex-start;align-items:flex-start;align-content:flex-start;flex-wrap:wrap;font-size:14px;']);
var ListItem = _styledComponents2.default.div.withConfig({
  displayName: 'EnumSelection__ListItem'
})(['line-height:16px;padding:13px 10px;border-radius:10px;font-weight:bold;margin:0 0 10px 10px;cursor:pointer;background-color:', ';color:', ';'], function (props) {
  return props.selected ? '#ffb400' : 'rgba(207,215,219,.3)';
}, function (props) {
  return props.selected ? '#ffffff' : '#688bac';
});

var EnumSelection = function (_React$PureComponent) {
  _inherits(EnumSelection, _React$PureComponent);

  // eslint-disable-line react/prefer-stateless-function
  function EnumSelection(props) {
    _classCallCheck(this, EnumSelection);

    var _this = _possibleConstructorReturn(this, (EnumSelection.__proto__ || Object.getPrototypeOf(EnumSelection)).call(this, props));

    var options = props.options.map(function (opt, index) {
      return {
        label: opt,
        id: index,
        isSelected: props.value && props.value === opt
      };
    });
    _this.state = {
      value: '',
      error: '',
      options: options
    };
    _this.setValue = _this.setValue.bind(_this);
    return _this;
  }

  _createClass(EnumSelection, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.setState(function () {
        return { value: _this2.props.value };
      }); // eslint-disable-line
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value) {
        this.setState(function () {
          return { value: nextProps.value };
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps !== this.props || nextState !== this.state;
    }
  }, {
    key: 'setValue',
    value: function setValue(option) {
      var options = this.state.options.map(function (opt) {
        return {
          label: opt.label,
          id: opt.id,
          isSelected: opt.id === option.id ? !opt.isSelected : open.isSelected
        };
      });
      var value = options.filter(function (opt) {
        return opt.id === option.id;
      })[0].isSelected ? option.label : null;
      this.setState(function () {
        return { options: options, value: value };
      });
      this.props.onSelected(value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        Wrapper,
        { id: this.props.id },
        _react2.default.createElement(
          ListWrapper,
          null,
          this.state.options.length && this.state.options.map(function (listItem) {
            return _react2.default.createElement(
              ListItem,
              {
                key: listItem.label,
                selected: listItem.isSelected,
                onClick: function onClick(e) {
                  e.preventDefault();_this3.setValue(listItem);
                }
              },
              listItem.label
            );
          })
        )
      );
    }
  }]);

  return EnumSelection;
}(_react2.default.PureComponent);

EnumSelection.propTypes = {
  options: _propTypes2.default.array,
  onSelected: _propTypes2.default.func,
  value: _propTypes2.default.string,
  id: _propTypes2.default.string
};

exports.default = EnumSelection;