'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _StyledInput = require('../StyledInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'FreeTextInput__Wrapper'
})(['display:block;position:relative;font-size:', ';width:100%;.error-section{display:block;font-size:inherit;color:#f26455;padding:0;margin:0;}'], function (props) {
  return props.fontSize + 'px';
});

var FreeTextInput = function (_React$Component) {
  _inherits(FreeTextInput, _React$Component);

  // eslint-disable-line react/prefer-stateless-function
  function FreeTextInput(props) {
    _classCallCheck(this, FreeTextInput);

    var _this = _possibleConstructorReturn(this, (FreeTextInput.__proto__ || Object.getPrototypeOf(FreeTextInput)).call(this, props));

    _this.state = {
      value: '',
      error: ''
    };
    _this.setValue = _this.setValue.bind(_this);
    _this.validate = _this.validate.bind(_this);
    return _this;
  }

  _createClass(FreeTextInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.setState(function () {
        return { value: _this2.props.value };
      }); // eslint-disable-line
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this3 = this;

      if (nextProps.value && nextProps.value !== this.state.value) {
        this.setValue(nextProps.value);
      }
      if (nextProps.initialValue && !this.state.initialized) {
        this.setState({ initialized: true }, function () {
          return _this3.setValue(nextProps.initialValue);
        });
      }
      if (nextProps.error) {
        this.setState(function () {
          return { error: nextProps.error };
        });
      }
    }
    // shouldComponentUpdate(nextProps, nextState) {
    //   return this.state.value !== nextState.value || this.state.error !== nextState.error;
    // }

  }, {
    key: 'setValue',
    value: function setValue(e) {
      var _this4 = this;

      try {
        e.preventDefault();
        this.setState({ value: e.target.value, error: '' }, function () {
          return _this4.props.onInputChanged({ value: _this4.state.value, error: _this4.state.error });
        });
      } catch (err) {
        this.setState({ value: e, error: '' }, function () {
          return _this4.props.onInputChanged({ value: _this4.state.value, error: _this4.state.error });
        });
      }
    }
  }, {
    key: 'validate',
    value: function validate() {
      if (this.props.isRequired && !this.state.value) {
        this.setState({ error: 'שדה חובה' });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        Wrapper,
        null,
        _react2.default.createElement(_StyledInput.StyledInput, _extends({}, this.props, {
          disabled: this.props.disabled,
          value: this.state.value,
          onChange: this.setValue,
          onBlur: this.validate,
          'aria-label': this.props.ariaLabel,
          fontSize: this.props.fontSize,
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          rtl: this.props.rtl,
          id: this.props.id
        })),
        _react2.default.createElement(
          'div',
          { className: 'error-section' },
          this.state.error
        )
      );
    }
  }]);

  return FreeTextInput;
}(_react2.default.Component);

FreeTextInput.propTypes = {
  disabled: _propTypes2.default.bool,
  isRequired: _propTypes2.default.bool,
  value: _propTypes2.default.string,
  initialValue: _propTypes2.default.string,
  rtl: _propTypes2.default.bool,
  ariaLabel: _propTypes2.default.string,
  onInputChanged: _propTypes2.default.func,
  id: _propTypes2.default.string
};

exports.default = FreeTextInput;