'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _StyledInput = require('../StyledInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'IsraeliIdNumber__Wrapper'
})(['display:block;position:relative;font-size:', ';width:100%;.error-section{display:block;font-size:inherit;color:#f26455;padding:0;margin:0;}'], function (props) {
  return props.fontSize + 'px';
});

var IsraeliIdNumber = function (_React$PureComponent) {
  _inherits(IsraeliIdNumber, _React$PureComponent);

  // eslint-disable-line react/prefer-stateless-function
  function IsraeliIdNumber(props) {
    _classCallCheck(this, IsraeliIdNumber);

    var _this = _possibleConstructorReturn(this, (IsraeliIdNumber.__proto__ || Object.getPrototypeOf(IsraeliIdNumber)).call(this, props));

    _this.state = {
      value: '',
      error: ''
    };
    _this.setValue = _this.setValue.bind(_this);
    _this.validate = _this.validate.bind(_this);
    return _this;
  }

  _createClass(IsraeliIdNumber, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.setState(function () {
        return { value: _this2.props.value };
      }); // eslint-disable-line
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps !== this.props || nextState !== this.state;
    }
  }, {
    key: 'setValue',
    value: function setValue(e) {
      e.preventDefault();
      var input = e.target.value;
      if (input.length <= 9) {
        var val = input.split('').filter(function (char) {
          return char.charCodeAt(0) > 47 && char.charCodeAt(0) < 58;
        }).join('');
        this.setState({ value: val, error: '' });
      }
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _this3 = this;

      var value = String(this.state.value).trim();
      if (value.length > 9 || value.length < 5 || isNaN(value)) {
        this.setState({ error: 'תעודת זהות לא תקינה' }, function () {
          return _this3.props.onIdChanged({ value: _this3.state.value, error: _this3.state.error });
        });
      } else {
        var paddedValue = value.padStart(9, '0');
        var accumulator = 0;
        var incrementor = 0;
        for (var index = 0; index < 9; index += 1) {
          incrementor = Number(paddedValue.charAt(index)) * (index % 2 + 1);
          accumulator += incrementor > 9 ? incrementor - 9 : incrementor;
        }
        if (accumulator % 10 !== 0) {
          this.setState({ error: 'תעודת זהות לא תקינה' }, function () {
            _this3.props.onIdChanged({ value: _this3.state.value, error: _this3.state.error });
            if (_this3.state.length === 9) {
              document.getElementById(_this3.props.id)[0].blur();
            }
          });
        } else {
          this.props.onIdChanged({ value: this.state.value, error: this.state.error });
          if (this.state.length === 9) {
            document.getElementById(this.props.id)[0].blur();
          }
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        Wrapper,
        null,
        _react2.default.createElement(_StyledInput.StyledInput, _extends({}, this.props, {
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          onChange: this.setValue,
          onBlur: this.validate,
          value: this.state.value,
          'aria-label': this.props.ariaLabel
          // className={'id-input'}
          , type: 'number',
          id: this.props.id
        })),
        _react2.default.createElement(
          'div',
          { className: 'error-section' },
          this.state.error
        )
      );
    }
  }]);

  return IsraeliIdNumber;
}(_react2.default.PureComponent);

IsraeliIdNumber.propTypes = {
  onIdChanged: _propTypes2.default.func,
  value: _propTypes2.default.string,
  id: _propTypes2.default.string,
  ariaLabel: _propTypes2.default.string
};

exports.default = IsraeliIdNumber;