'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _googleLibphonenumber = require('google-libphonenumber');

var _StyledInput = require('../StyledInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'PhoneNumberInput__Wrapper'
})(['display:block;position:relative;width:100%;font-size:', ';direction:ltr;input{direction:ltr;::placeholder{direction:', ';}::-webkit-input-placeholder{direction:', ';}}.prefix-section{display:inline-block;width:25%;min-width:3em;}.number-section{display:inline-block;width:calc(75% - 0.5em);max-width:10em;margin-left:0.5em;}.error-section{font-size:inherit;direction:', ';color:#f26455;padding:0;margin:0;}'], function (props) {
  return props.fontSize + 'px';
}, function (props) {
  return props.rtl ? 'rtl' : 'ltr';
}, function (props) {
  return props.rtl ? 'rtl' : 'ltr';
}, function (props) {
  return props.rtl ? 'rtl' : 'ltr';
});
var phoneUtils = _googleLibphonenumber.PhoneNumberUtil.getInstance();

var PhoneNumberInput = function (_React$Component) {
  _inherits(PhoneNumberInput, _React$Component);

  // eslint-disable-line react/prefer-stateless-function
  function PhoneNumberInput(props) {
    _classCallCheck(this, PhoneNumberInput);

    var _this = _possibleConstructorReturn(this, (PhoneNumberInput.__proto__ || Object.getPrototypeOf(PhoneNumberInput)).call(this, props));

    _this.state = {
      prefix: '',
      phoneNumber: '',
      error: ''
    };
    _this.setPrefix = _this.setPrefix.bind(_this);
    _this.setNumber = _this.setNumber.bind(_this);
    _this.validate = _this.validate.bind(_this);
    return _this;
  }

  _createClass(PhoneNumberInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      console.log(this.props);
      if (this.props.value) {
        var value = this.props.value;
        if (value[1] === '5' || value[1] === '7') {
          this.setState(function () {
            return { prefix: value.slice(0, 3), phoneNumber: value.slice(3) };
          }); // eslint-disable-line
        } else {
          this.setState(function () {
            return { prefix: value.slice(0, 2), phoneNumber: value.slice(2) };
          });
        } // eslint-disable-line
      }
    }
  }, {
    key: 'setPrefix',
    value: function setPrefix(e) {
      var input = e.target.value;
      e.preventDefault();
      if (input.startsWith('0') && input.length <= 3 || !input.length) {
        var val = input.split('').filter(function (char) {
          return char.charCodeAt(0) > 47 && char.charCodeAt(0) < 58;
        }).join('');
        this.setState({ prefix: val, error: '' });
        if (input.length === 3) {
          document.getElementById('number-section-' + this.props.id).focus();
        }
      }
    }
  }, {
    key: 'setNumber',
    value: function setNumber(e) {
      var input = e.target.value;
      e.preventDefault();
      if (input.length <= 7) {
        var val = input.split('').filter(function (char) {
          return char.charCodeAt(0) > 47 && char.charCodeAt(0) < 58;
        }).join('');
        this.setState({ phoneNumber: val, error: '' });
      }
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _this2 = this;

      try {
        var formattedNumber = phoneUtils.parse('' + this.state.prefix + this.state.phoneNumber, 'IL');
        var isValidNumber = phoneUtils.isValidNumber(formattedNumber);
        if (!isValidNumber) {
          this.setState({ error: 'מספר לא תקין' }, function () {
            return _this2.props.onPhoneNumberChanged({ value: '' + _this2.state.prefix + _this2.state.phoneNumber, error: _this2.state.error });
          });
        }
        this.props.onPhoneNumberChanged({ value: '' + this.state.prefix + this.state.phoneNumber, error: this.state.error });
      } catch (e) {
        this.setState({ error: 'מספר לא תקין' });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        Wrapper,
        { rtl: this.props.rtl, fontSize: this.props.fontSize },
        _react2.default.createElement(_StyledInput.StyledInput, _extends({}, this.props, {
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          className: 'prefix-section',
          value: this.state.prefix,
          onChange: this.setPrefix,
          'aria-label': this.props.ariaLabel,
          maxLength: 3,
          placeholder: '',
          type: 'number',
          rtl: this.props.rtl
        })),
        _react2.default.createElement(_StyledInput.StyledInput, _extends({}, this.props, {
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          className: 'number-section',
          onChange: this.setNumber,
          onBlur: this.validate,
          value: this.state.phoneNumber,
          'aria-label': this.props.ariaLabel,
          type: 'number',
          rtl: this.props.rtl,
          id: 'number-section-' + this.props.id
        })),
        _react2.default.createElement(
          'div',
          { className: 'error-section' },
          this.state.error
        )
      );
    }
  }]);

  return PhoneNumberInput;
}(_react2.default.Component);

PhoneNumberInput.propTypes = {
  onPhoneNumberChanged: _propTypes2.default.func,
  value: _propTypes2.default.string,
  ariaLabel: _propTypes2.default.string,
  id: _propTypes2.default.string
};

exports.default = PhoneNumberInput;