'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _StyledInput = require('../StyledInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'PlateNumberInput__Wrapper'
})(['display:block;position:relative;font-size:', ';width:100%;.error-section{display:block;font-size:inherit;color:#f26455;padding:0;margin:0;}'], function (props) {
  return props.fontSize + 'px';
});

var PlateNumberInput = function (_React$PureComponent) {
  _inherits(PlateNumberInput, _React$PureComponent);

  // eslint-disable-line react/prefer-stateless-function
  function PlateNumberInput(props) {
    _classCallCheck(this, PlateNumberInput);

    var _this = _possibleConstructorReturn(this, (PlateNumberInput.__proto__ || Object.getPrototypeOf(PlateNumberInput)).call(this, props));

    _this.state = {
      value: '',
      error: ''
    };
    _this.setValue = _this.setValue.bind(_this);
    _this.validate = _this.validate.bind(_this);
    return _this;
  }

  _createClass(PlateNumberInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.setState(function () {
        return { value: _this2.props.value };
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value) {
        this.setState(function () {
          return { value: nextProps.value };
        });
      }
      if (nextProps.missing) {
        this.setState({ error: 'שדה חובה' });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps !== this.props || nextState !== this.state;
    }
  }, {
    key: 'setValue',
    value: function setValue(e) {
      var _this3 = this;

      var input = e.target.value;
      e.preventDefault();
      if (input.length <= 8) {
        var val = input.split('').filter(function (char) {
          return char.charCodeAt(0) > 47 && char.charCodeAt(0) < 58;
        }).join('');
        this.setState({ value: val, error: '' }, function () {
          return _this3.state.value.length >= 7 ? _this3.validate() : null;
        });
      }
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _this4 = this;

      if (isNaN(this.state.value)) {
        this.setState({ error: 'מספר לא תקין' }, function () {
          return _this4.props.onPlateNumChanges({ value: _this4.state.value, error: _this4.state.error });
        });
      }
      if (String(this.state.value).trim().length < 7) {
        this.setState({ error: 'מספר לא תקין' }, function () {
          return _this4.props.onPlateNumChanges({ value: _this4.state.value, error: _this4.state.error });
        });
      } else {
        this.props.onPlateNumChanges({ value: this.state.value, error: this.state.error });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        Wrapper,
        null,
        _react2.default.createElement(_StyledInput.StyledInput, _extends({}, this.props, {
          style: this.state.error ? _StyledInput.errorInlineStyle : {},
          onChange: this.setValue,
          onBlur: this.validate,
          value: this.state.value,
          'aria-label': this.props.ariaLabel,
          type: 'number',
          rtl: this.props.rtl
        })),
        _react2.default.createElement(
          'div',
          { className: 'error-section' },
          this.state.error
        )
      );
    }
  }]);

  return PlateNumberInput;
}(_react2.default.PureComponent);

PlateNumberInput.propTypes = {
  onPlateNumChanges: _propTypes2.default.func,
  value: _propTypes2.default.string,
  ariaLabel: _propTypes2.default.string,
  missing: _propTypes2.default.bool,
  rtl: _propTypes2.default.bool
};

exports.default = PlateNumberInput;