'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _iconGenderMalPre = require('./icon-gender-mal-pre.svg');

var _iconGenderMalPre2 = _interopRequireDefault(_iconGenderMalPre);

var _iconGenderMalRel = require('./icon-gender-mal-rel.svg');

var _iconGenderMalRel2 = _interopRequireDefault(_iconGenderMalRel);

var _iconGenderFemPre = require('./icon-gender-fem-pre.svg');

var _iconGenderFemPre2 = _interopRequireDefault(_iconGenderFemPre);

var _iconGenderFemRel = require('./icon-gender-fem-rel.svg');

var _iconGenderFemRel2 = _interopRequireDefault(_iconGenderFemRel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'SelectGender__Wrapper'
})(['display:flex;b{font-size:14px;font-weight:bold;text-align:right;color:#202a31;}']);
var Female = _styledComponents2.default.div.withConfig({
  displayName: 'SelectGender__Female'
})(['display:flex;flex-direction:column;align-content:center;justify-content:space-between;.female-icon{img{width:60px;height:60px;}cursor:pointer;}.female-label{font-size:14px;font-weight:bold;color:#313f4d;opacity:', ';display:flex;justify-content:center;align-items:center;}'], function (props) {
  return props.isFemale ? '1' : '0.3';
});
var Male = _styledComponents2.default.div.withConfig({
  displayName: 'SelectGender__Male'
})(['margin:0 20px;display:flex;flex-direction:column;align-content:center;justify-content:space-between;.male-icon{img{width:60px;height:60px;}cursor:pointer;}.male-label{font-size:14px;font-weight:bold;color:#313f4d;opacity:', ';display:flex;justify-content:center;align-items:center;}'], function (props) {
  return props.isMale ? '1' : '0.3';
});

var SelectGender = function (_React$PureComponent) {
  _inherits(SelectGender, _React$PureComponent);

  // eslint-disable-line react/prefer-stateless-function
  function SelectGender(props) {
    _classCallCheck(this, SelectGender);

    var _this = _possibleConstructorReturn(this, (SelectGender.__proto__ || Object.getPrototypeOf(SelectGender)).call(this, props));

    _this.state = {
      value: '',
      error: ''
    };
    _this.setValue = _this.setValue.bind(_this);
    return _this;
  }

  _createClass(SelectGender, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({ value: this.props.value }); // eslint-disable-line
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value) {
        this.setState(function () {
          return { value: nextProps.value };
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps.value !== this.props.value || nextState.value !== this.state.value;
    }
  }, {
    key: 'setValue',
    value: function setValue(value) {
      var _this2 = this;

      this.setState({ value: value === this.state.value ? null : value, error: '' }, function () {
        return _this2.props.onGenderSelected(_this2.state.value);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        Wrapper,
        null,
        _react2.default.createElement(
          'b',
          null,
          '\u05DE\u05D9\u05DF'
        ),
        _react2.default.createElement(
          'div',
          { style: { display: 'flex' } },
          _react2.default.createElement(
            Male,
            { isMale: this.state.value && this.state.value === 'זכר', onClick: function onClick() {
                return _this3.setValue('זכר');
              } },
            _react2.default.createElement(
              'div',
              { className: 'male-icon' },
              _react2.default.createElement('img', { src: this.state.value === 'זכר' ? _iconGenderMalPre2.default : _iconGenderMalRel2.default, alt: '' })
            ),
            _react2.default.createElement(
              'div',
              { className: 'male-label' },
              '\u05D6\u05DB\u05E8'
            )
          ),
          _react2.default.createElement(
            Female,
            { isFemale: this.state.value && this.state.value === 'נקבה', onClick: function onClick() {
                return _this3.setValue('נקבה');
              } },
            _react2.default.createElement(
              'div',
              { className: 'female-icon' },
              _react2.default.createElement('img', { src: this.state.value === 'נקבה' ? _iconGenderFemPre2.default : _iconGenderFemRel2.default, alt: '' })
            ),
            _react2.default.createElement(
              'div',
              { className: 'female-label' },
              '\u05E0\u05E7\u05D1\u05D4'
            )
          )
        )
      );
    }
  }]);

  return SelectGender;
}(_react2.default.PureComponent);

SelectGender.propTypes = {
  value: _propTypes2.default.string,
  onGenderSelected: _propTypes2.default.func
};

exports.default = SelectGender;