'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require('react-transition-group/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var popAnimation = 'all 0.25s cubic-bezier(0.755, 0.125, 0.180, 0.910)';

var SwitchContainerOn = {
  direction: 'ltr !important',
  minWidth: '80px',
  height: '45px',
  display: 'block',
  borderRadius: '22.5px',
  backgroundColor: 'rgba(247, 184, 0, 0.25)',
  border: 'solid 1px #f7b800',
  cursor: 'pointer'
};
var SwitchContainerOff = {
  direction: 'ltr !important',
  minWidth: '80px',
  height: '45px',
  display: 'block',
  borderRadius: '22.5px',
  backgroundColor: 'rgba(148, 172, 191, 0.25)',
  border: 'solid 1px #94acbf',
  cursor: 'pointer'
};
var StyledKnobOff = {
  outline: 'none',
  position: 'relative',
  top: '-45px',
  width: '35px',
  height: '35px',
  borderRadius: '100%',
  backgroundColor: '#ffffff',
  margin: '5px',
  transition: popAnimation,
  boxShadow: '0 5px 5px 0 rgba(68, 87, 107, 0.4)',
  transform: 'translateX(0)',
  cursor: 'pointer',
  backgroundImage: 'linear-gradient(to top, rgba(119,139,156,.3), #ffffff), linear-gradient(#ffffff, #ffffff)'
};
var StyledKnobOn = {
  outline: 'none',
  position: 'relative',
  top: '-45px',
  width: '35px',
  height: '35px',
  borderRadius: '100%',
  backgroundColor: '#ffffff',
  margin: '5px',
  transition: popAnimation,
  boxShadow: '0 5px 5px 0 rgba(226, 149, 0, 0.4)',
  transform: 'translateX(35px)',
  cursor: 'pointer',
  backgroundImage: 'linear-gradient(to top, rgba(232,159,0,.3), #ffffff), linear-gradient(#ffffff, #ffffff)'
};
var SwitchTransform = {
  entering: {},
  entered: SwitchContainerOn
};
var SwitchKnobTransform = {
  entering: {},
  entered: StyledKnobOn
};

var SwitchButton = function (_React$Component) {
  _inherits(SwitchButton, _React$Component);

  // eslint-disable-line react/prefer-stateless-function
  function SwitchButton(props) {
    _classCallCheck(this, SwitchButton);

    var _this = _possibleConstructorReturn(this, (SwitchButton.__proto__ || Object.getPrototypeOf(SwitchButton)).call(this, props));

    _this.state = {
      value: false
    };
    _this.setValue = _this.setValue.bind(_this);
    return _this;
  }

  _createClass(SwitchButton, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps !== this.props || nextState !== this.state;
    }
  }, {
    key: 'setValue',
    value: function setValue(e) {
      var _this2 = this;

      e.preventDefault();
      this.setState({ value: this.state.value === false }, function () {
        return _this2.props.onChange(_this2.state.value);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'button',
        { style: { position: 'relative', height: '45px', outline: 'none' }, onClick: this.setValue },
        _react2.default.createElement(
          _Transition2.default,
          { 'in': this.state.value, timeout: { enter: 200, exit: 200 } },
          function (state) {
            return _react2.default.createElement('div', {
              style: _extends({}, SwitchContainerOff, SwitchTransform[state])
            });
          }
        ),
        _react2.default.createElement(
          _Transition2.default,
          { 'in': this.state.value, timeout: { enter: 200, exit: 200 } },
          function (state) {
            return _react2.default.createElement('div', {
              style: _extends({}, StyledKnobOff, SwitchKnobTransform[state])
            });
          }
        )
      );
    }
  }]);

  return SwitchButton;
}(_react2.default.Component);

SwitchButton.propTypes = {
  onChange: _propTypes2.default.func
};

exports.default = SwitchButton;